diff --git a/drivers/gpu/drm/drm_auth.c b/drivers/gpu/drm/drm_auth.c
index b7230604496b..0acb444fbbac 100644
--- a/drivers/gpu/drm/drm_auth.c
+++ b/drivers/gpu/drm/drm_auth.c
@@ -98,10 +98,10 @@ int drm_getmagic(struct drm_device *dev, void *data, struct drm_file *file_priv)
 	struct drm_master *master;
 	int ret = 0;
 
-	mutex_lock(&dev->master_mutex);
+	spin_lock(&dev->master_lookup_lock);
 	master = file_priv->master;
 	if (!master) {
-		mutex_unlock(&dev->master_mutex);
+		spin_unlock(&dev->master_lookup_lock);
 		return -EINVAL;
 	}
 
@@ -112,7 +112,7 @@ int drm_getmagic(struct drm_device *dev, void *data, struct drm_file *file_priv)
 			file_priv->magic = ret;
 	}
 	auth->magic = file_priv->magic;
-	mutex_unlock(&dev->master_mutex);
+	spin_unlock(&dev->master_lookup_lock);
 
 	DRM_DEBUG("%u\n", auth->magic);
 
@@ -127,13 +127,13 @@ int drm_authmagic(struct drm_device *dev, void *data,
 
 	DRM_DEBUG("%u\n", auth->magic);
 
-	mutex_lock(&dev->master_mutex);
+	spin_lock(&dev->master_lookup_lock);
 	file = idr_find(&file_priv->master->magic_map, auth->magic);
 	if (file) {
 		file->authenticated = 1;
 		idr_replace(&file_priv->master->magic_map, NULL, auth->magic);
 	}
-	mutex_unlock(&dev->master_mutex);
+	spin_unlock(&dev->master_lookup_lock);
 
 	return file ? 0 : -EINVAL;
 }
@@ -366,8 +366,10 @@ void drm_master_release(struct drm_file *file_priv)
 	if (!master)
 		goto unlock;
 
+	spin_lock(&dev->master_lookup_lock);
 	if (file_priv->magic)
 		idr_remove(&master->magic_map, file_priv->magic);
+	spin_unlock(&dev->master_lookup_lock);
 
 	if (!drm_is_current_master_locked(file_priv))
 		goto out;
diff --git a/drivers/gpu/drm/drm_ioctl.c b/drivers/gpu/drm/drm_ioctl.c
index 4d029d3061d9..e5c3845b6e62 100644
--- a/drivers/gpu/drm/drm_ioctl.c
+++ b/drivers/gpu/drm/drm_ioctl.c
@@ -119,21 +119,21 @@ int drm_getunique(struct drm_device *dev, void *data,
 	struct drm_unique *u = data;
 	struct drm_master *master;
 
-	mutex_lock(&dev->master_mutex);
+	spin_lock(&dev->master_lookup_lock);
 	master = file_priv->master;
 	if (!master) {
-		mutex_unlock(&dev->master_mutex);
+		spin_unlock(&dev->master_lookup_lock);
 		return -EINVAL;
 	}
 
 	if (u->unique_len >= master->unique_len) {
 		if (copy_to_user(u->unique, master->unique, master->unique_len)) {
-			mutex_unlock(&dev->master_mutex);
+			spin_unlock(&dev->master_lookup_lock);
 			return -EFAULT;
 		}
 	}
 	u->unique_len = master->unique_len;
-	mutex_unlock(&dev->master_mutex);
+	spin_unlock(&dev->master_lookup_lock);
 
 	return 0;
 }
@@ -405,7 +405,9 @@ static int drm_setversion(struct drm_device *dev, void *data, struct drm_file *f
 			 * Version 1.1 includes tying of DRM to specific device
 			 * Version 1.4 has proper PCI domain support
 			 */
+			spin_lock(&dev->master_lookup_lock);
 			retcode = drm_set_busid(dev, file_priv);
+			spin_unlock(&dev->master_lookup_lock);
 			if (retcode)
 				goto done;
 		}
diff --git a/include/drm/drm_auth.h b/include/drm/drm_auth.h
index ba248ca8866f..f5be73153798 100644
--- a/include/drm/drm_auth.h
+++ b/include/drm/drm_auth.h
@@ -67,17 +67,17 @@ struct drm_master {
 	struct drm_device *dev;
 	/**
 	 * @unique: Unique identifier: e.g. busid. Protected by
-	 * &drm_device.master_mutex.
+	 * &drm_device.master_lookup_lock.
 	 */
 	char *unique;
 	/**
 	 * @unique_len: Length of unique field. Protected by
-	 * &drm_device.master_mutex.
+	 * &drm_device.master_lookup_lock.
 	 */
 	int unique_len;
 	/**
 	 * @magic_map: Map of used authentication tokens. Protected by
-	 * &drm_device.master_mutex.
+	 * &drm_device.master_lookup_lock.
 	 */
 	struct idr magic_map;
 	void *driver_priv;
diff --git a/include/drm/drm_device.h b/include/drm/drm_device.h
index 506eb2784819..cf5d15aeb25f 100644
--- a/include/drm/drm_device.h
+++ b/include/drm/drm_device.h
@@ -152,7 +152,12 @@ struct drm_device {
 	 */
 	struct mutex master_mutex;
 
-	/** @master_lookup_lock: Serializes &drm_file.master. */
+	/**
+	 * @master_lookup_lock:
+	 *
+	 * Serializes &drm_file.master, &drm_master.magic_map,
+	 * &drm_master.unique, and &drm_master.unique_len.
+	 */
 	spinlock_t master_lookup_lock;
 
 	/**